<!doctype html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1, minimum-scale=1" />
<meta name="generator" content="pdoc 0.8.1" />
<title>src.file_management API documentation</title>
<meta name="description" content="Here we define some fuctions for writing and reading statistical data to or
from JSON files, save plots to pdf files, and save and load graph samples." />
<link href='https://cdnjs.cloudflare.com/ajax/libs/normalize/8.0.0/normalize.min.css' rel='stylesheet'>
<link href='https://cdnjs.cloudflare.com/ajax/libs/10up-sanitize.css/8.0.0/sanitize.min.css' rel='stylesheet'>
<link href="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/styles/github.min.css" rel="stylesheet">
<style>.flex{display:flex !important}body{line-height:1.5em}#content{padding:20px}#sidebar{padding:30px;overflow:hidden}#sidebar > *:last-child{margin-bottom:2cm}.http-server-breadcrumbs{font-size:130%;margin:0 0 15px 0}#footer{font-size:.75em;padding:5px 30px;border-top:1px solid #ddd;text-align:right}#footer p{margin:0 0 0 1em;display:inline-block}#footer p:last-child{margin-right:30px}h1,h2,h3,h4,h5{font-weight:300}h1{font-size:2.5em;line-height:1.1em}h2{font-size:1.75em;margin:1em 0 .50em 0}h3{font-size:1.4em;margin:25px 0 10px 0}h4{margin:0;font-size:105%}a{color:#058;text-decoration:none;transition:color .3s ease-in-out}a:hover{color:#e82}.title code{font-weight:bold}h2[id^="header-"]{margin-top:2em}.ident{color:#900}pre code{background:#f8f8f8;font-size:.8em;line-height:1.4em}code{background:#f2f2f1;padding:1px 4px;overflow-wrap:break-word}h1 code{background:transparent}pre{background:#f8f8f8;border:0;border-top:1px solid #ccc;border-bottom:1px solid #ccc;margin:1em 0;padding:1ex}#http-server-module-list{display:flex;flex-flow:column}#http-server-module-list div{display:flex}#http-server-module-list dt{min-width:10%}#http-server-module-list p{margin-top:0}.toc ul,#index{list-style-type:none;margin:0;padding:0}#index code{background:transparent}#index h3{border-bottom:1px solid #ddd}#index ul{padding:0}#index h4{margin-top:.6em;font-weight:bold}@media (min-width:200ex){#index .two-column{column-count:2}}@media (min-width:300ex){#index .two-column{column-count:3}}dl{margin-bottom:2em}dl dl:last-child{margin-bottom:4em}dd{margin:0 0 1em 3em}#header-classes + dl > dd{margin-bottom:3em}dd dd{margin-left:2em}dd p{margin:10px 0}.name{background:#eee;font-weight:bold;font-size:.85em;padding:5px 10px;display:inline-block;min-width:40%}.name:hover{background:#e0e0e0}.name > span:first-child{white-space:nowrap}.name.class > span:nth-child(2){margin-left:.4em}.inherited{color:#999;border-left:5px solid #eee;padding-left:1em}.inheritance em{font-style:normal;font-weight:bold}.desc h2{font-weight:400;font-size:1.25em}.desc h3{font-size:1em}.desc dt code{background:inherit}.source summary,.git-link-div{color:#666;text-align:right;font-weight:400;font-size:.8em;text-transform:uppercase}.source summary > *{white-space:nowrap;cursor:pointer}.git-link{color:inherit;margin-left:1em}.source pre{max-height:500px;overflow:auto;margin:0}.source pre code{font-size:12px;overflow:visible}.hlist{list-style:none}.hlist li{display:inline}.hlist li:after{content:',\2002'}.hlist li:last-child:after{content:none}.hlist .hlist{display:inline;padding-left:1em}img{max-width:100%}.admonition{padding:.1em .5em;margin-bottom:1em}.admonition-title{font-weight:bold}.admonition.note,.admonition.info,.admonition.important{background:#aef}.admonition.todo,.admonition.versionadded,.admonition.tip,.admonition.hint{background:#dfd}.admonition.warning,.admonition.versionchanged,.admonition.deprecated{background:#fd4}.admonition.error,.admonition.danger,.admonition.caution{background:lightpink}</style>
<style media="screen and (min-width: 700px)">@media screen and (min-width:700px){#sidebar{width:30%;height:100vh;overflow:auto;position:sticky;top:0}#content{width:70%;max-width:100ch;padding:3em 4em;border-left:1px solid #ddd}pre code{font-size:1em}.item .name{font-size:1em}main{display:flex;flex-direction:row-reverse;justify-content:flex-end}.toc ul ul,#index ul{padding-left:1.5em}.toc > ul > li{margin-top:.5em}}</style>
<style media="print">@media print{#sidebar h1{page-break-before:always}.source{display:none}}@media print{*{background:transparent !important;color:#000 !important;box-shadow:none !important;text-shadow:none !important}a[href]:after{content:" (" attr(href) ")";font-size:90%}a[href][title]:after{content:none}abbr[title]:after{content:" (" attr(title) ")"}.ir a:after,a[href^="javascript:"]:after,a[href^="#"]:after{content:""}pre,blockquote{border:1px solid #999;page-break-inside:avoid}thead{display:table-header-group}tr,img{page-break-inside:avoid}img{max-width:100% !important}@page{margin:0.5cm}p,h2,h3{orphans:3;widows:3}h1,h2,h3,h4,h5,h6{page-break-after:avoid}}</style>
</head>
<body>
<main>
<article id="content">
<header>
<h1 class="title">Module <code>src.file_management</code></h1>
</header>
<section id="section-intro">
<p>Here we define some fuctions for writing and reading statistical data to or
from JSON files, save plots to pdf files, and save and load graph samples.</p>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">&#34;&#34;&#34;Here we define some fuctions for writing and reading statistical data to or
from JSON files, save plots to pdf files, and save and load graph samples.
&#34;&#34;&#34;

from pathlib import Path
import os
import json
from datetime import datetime
import glob
from os.path import join
import matplotlib.pyplot as plt
from src.config import STATISTICS_FOLDER_NAME, PLOTS_FOLDER_NAME, GRAPH_SAMPLES_FOLDER_NAME
import pandas as pd
import networkx as nx
import pickle


def save_statistics_from_dataframe(df, db_property: str):
    &#34;&#34;&#34;Saves database statistics from a dataframe to a newly created JSON file
     in the statistics folder.

    The name of the created file has the following format:
    &#34;stats__[`db_property`]__[timestamp].json&#34;

    Parameters
    ----------
    df: &#39;pandas.core.frame.DataFrame&#39;
        the statistical data that should be saved in JSON file
    db_property: str
        Name of the property, of which `df` contains information. This name
        will be part of the name of the created JSON file.

    &#34;&#34;&#34;
    #data_dict = df.to_dict()
    #save_statistics_from_dict(data_dict, db_property)


    filename = construct_filename(db_property)

    df.to_json(filename, orient=&#39;columns&#39;)

    print(&#34;Data saved as {}.&#34;.format(filename))



def save_statistics_from_dict(statistics: dict, db_property: str):
    &#34;&#34;&#34;Saves database statistics from a dictionary to a newly created JSON file
     in the statistics folder.

    The name of the created file has the following format:
    &#34;stats__&#34; + `db_property` + &#34;__&#34; + timestamp + &#34;.json&#34;

    Parameters
    ----------
    statistics: dictionary
        the statistical data that should be saved. The exact structure of the
        dict depends on the measured property
    db_property: str
        describes the property of which the statistics should be saved

    &#34;&#34;&#34;

    filename = construct_filename(db_property)

    with open(filename, &#39;w&#39;) as file:
        json.dump(statistics, file)

    print(&#34;Data saved as {}.&#34;.format(filename))



def construct_filename(property_name: str):
    &#34;&#34;&#34;Return a filename of the following format:

    &#34;stats__&#34; + `property_name` + &#34;__&#34; + timestamp + &#34;.json&#34;

    The timestamp will be set according to the system time.


    Parameters
    ----------
    property_name: str
        describes a property of teh database in words

    Returns
    -------
    str
        the filename following the format above

    &#34;&#34;&#34;
    # create folder, if it not exists:
    Path(os.path.join(os.getcwd()), STATISTICS_FOLDER_NAME).mkdir(exist_ok=True)

    timestamp = int(datetime.now().timestamp()) # timestamp of when the data was saved
    # (it should be saved directly after running the query as it is more important to
    # know when the query was run that when it was saved)

    filename = &#34;{}/stats__{}__{}.json&#34;.format(STATISTICS_FOLDER_NAME, property_name, timestamp)

    return filename



def find_stats_files(property_name: str):
    &#34;&#34;&#34;Returns all names of json files containing collected statistical data
    of the graph database property specified by `property_name`.

    Parameters
    ----------
    name: str
        The name of a graph property

    Returns
    -------
    list of str
        The filenames of json files in the statistics folder matching the
        following pattern:
        &#34;stats__&#34; + `property_name` + &#34;__&#34; + timestamp + &#34;.json&#34;
    &#34;&#34;&#34;
    files = [f for f in glob.glob(join(STATISTICS_FOLDER_NAME, &#39;stats__{}__*.json&#39;.format(property_name)))]
    return files



def find_newest_stats_file(property_name: str):
    &#34;&#34;&#34;Returns name of newest json file containing collected statistical data
    of the graph database property specified by `property_name` and the time of
    the database access.

    Parameters
    ----------
    name: str
        The name of a graph property

    Returns
    -------
    str
        The filename of the most recent json file in the statistics folder
        matching the following pattern:
        &#34;stats__&#34; + `property_name` + &#34;__&#34; + timestamp + &#34;.json&#34;

    datetime.datetime
        The time when the file was created

    &#34;&#34;&#34;
    data_files = find_stats_files(property_name)

    if not data_files:
        print(&#34;ERROR: File loading failed because there are no statistics of the requested property. Please check your spelling of the property name.&#34;)
        return None, None

    #extract timestamps from filname strs:
    timestamps = [int(filename.split(&#34;.&#34;)[0].split(&#34;__&#34;)[-1]) for filename in data_files]
    times = [datetime.fromtimestamp(timestamps[i]) for i in range(len(data_files))]

    #find index of most recent file
    newest = times.index(max(times))

    return data_files[newest], times[newest]



def find_all_stats_files(property_name: str):
    &#34;&#34;&#34;Returns names of all json file containing collected statistical data
    of the graph database property specified by `property_name`togehter with the
     times of the database accesses.

    Parameters
    ----------
    name: str
        The name of a graph property

    Returns
    -------
    str
        The filenames of all json files in the statistics folder
        matching the following pattern:
        &#34;stats__&#34; + `property_name` + &#34;__&#34; + timestamp + &#34;.json&#34;

    datetime.datetime
        The times when the stats files were created (usually immediately
         after the database access)

    &#34;&#34;&#34;
    data_files = find_stats_files(property_name)

    if not data_files:
        print(&#34;ERROR: File loading failed because there are no statistics of the requested property. Please check your spelling of the property name.&#34;)
        return None, None

    #extract timestamps from filname strs:
    timestamps = [int(filename.split(&#34;.&#34;)[0].split(&#34;__&#34;)[-1]) for filename in data_files]
    times = [datetime.fromtimestamp(timestamps[i]) for i in range(len(data_files))]

    return data_files, times



def load_statistics(property_name: str):
    &#34;&#34;&#34;Loads newest statistical data from a JSON-file inside the statistics
    folder.

    Parameters
    ----------
    property_name: str
        name of a property of the graph database. This should also be the name
        of a JSON file containing the desired statistics

    Returns
    -------
    dict
        The data from the json file specified by `filename`
    datetime.datetime
        The time when the statistics file was created
    &#34;&#34;&#34;

    filename, time_created = find_newest_stats_file(property_name)
    if filename:
        with open(filename, &#34;r&#34;) as read_file:
            data = json.load(read_file)

        return data, time_created
    else:
        return None, None



def load_all_statistics(property_name: str):
    &#34;&#34;&#34;Loads all statistical data from a JSON-file inside the statistics folder.

    Parameters
    ----------
    property_name: str
        name of a property of the graph database. This should also be the name of
        a JSON file containing the desired statistics

    Returns
    -------
    dict
        The data from the json file specified by `filename`
    datetime.datetime
        The time when the statistics file was created
    &#34;&#34;&#34;

    data_list = []
    time_created_list = []

    filenames, times_created = find_all_stats_files(property_name)
    for filename, time_created in zip(filenames,times_created):
        if filename:
            with open(filename, &#34;r&#34;) as read_file:
                data = json.load(read_file)

            data_list.append(data)
            time_created_list.append(time_created)
        else:
            data_list.append(None)
            time_created_list.append(None)

    return data_list, time_created_list



def save_plot(property_name: str):
    &#34;&#34;&#34;Saves a matplotlib plot as png file in the plots folder.

    The name of the saved image file will be of the following format:
    &#34;plot__&#34; + `property_name` + &#34;__&#34; + timestamp + &#34;.png&#34;

    Parameters
    ----------
    property_name: str
        The name of the property that the plots contains information of.
    &#34;&#34;&#34;
    timestamp = int(datetime.now().timestamp()) # timestamp of when the plot was created
    filename = &#34;{}/plot__{}__{}.pdf&#34;.format(PLOTS_FOLDER_NAME, property_name, timestamp)
    plt.savefig(filename, format=&#34;pdf&#34;, dpi=300, bbox_inches = &#39;tight&#39;)

    print(&#34;Plot saved as {}.&#34;.format(filename))



def save_sample(graph:nx.Graph, sampling_method:str):
    &#34;&#34;&#34; Saves a graph sample as both pickle file and gexf file.

    A timestamp will be created which will be part of the filename of both
    created files.

    The pickle file will contained a serialized version of the networkx graph
    that we can load again easily to further compute statistics on the sample.

    The gexf file can be used to visualize the graph with Gephi.


    Parameters
    ----------
    graph: nx.Graph
        A networkx graph object representing a graph sample.
    sampling_method: str
        The name of the used sampling method,
        e.g. random_walk or random_node_selection
    &#34;&#34;&#34;
    # Create timestamp of when the gexf file was created to
    # 1) distinguish between different samples with same parameters
    # 2) database is changing. File should be saved directly after sample
    #    creation to now in which state the database was a time of sampling
    timestamp = int(datetime.now().timestamp())
    sample_size = graph.number_of_nodes()
    filename_prefix = &#34;{}/sample__{}__{}__{}&#34;.format(GRAPH_SAMPLES_FOLDER_NAME, sampling_method, sample_size, timestamp)

    #save pickle:
    filename_pickle = filename_prefix + &#34;.pickle&#34;
    with open(filename_pickle, &#39;wb&#39;) as f:
        pickle.dump(graph, f)
    print(&#34;Sample graph saved as {}.&#34;.format(filename_pickle))

    #save gexf:
    filename_gexf = filename_prefix + &#34;.gexf&#34;
    nx.write_gexf(graph, filename_gexf)
    print(&#34;Gephi readable file saved as {}.&#34;.format(filename_gexf))



def load_samples(sampling_method:str, size:int):
    &#34;&#34;&#34;Returns all stored graph samples with specified parameters.

    Parameters
    ----------
    name: str
        The name of a sampling method for which we want to find the created
        samples.
    size: int
        The size of the samples for which we want to find the files.

    Returns
    -------
    list of nx.Graph
        graph samples with specified sampling method and size
    &#34;&#34;&#34;
    files = find_sample_files(sampling_method, size)
    samples = []
    for filename in files:
        with open(filename, &#39;rb&#39;) as f:
            sample = pickle.load(f)
            samples.append(sample)
    return samples



def find_sample_files(sampling_method:str, size:int):
    &#34;&#34;&#34;Returns all names of pickle files containing serialized graph samples
    of the graph database sampled by the specified method.

    Parameters
    ----------
    name: str
        The name of a sampling method for which we want to find the created
        samples.
    size: int
        The size of the samples for which we want to find the files.

    Returns
    -------
    list of str
        The filenames of pickle files in the graph samples folder matching the
        following pattern:
        &#34;sample__&#34; + `sampling_method` + * + &#34;.pickle&#34;
    &#34;&#34;&#34;
    files = [f for f in glob.glob(join(GRAPH_SAMPLES_FOLDER_NAME, &#39;sample__{}__{}__*.pickle&#39;.format(sampling_method, size)))]

    return files</code></pre>
</details>
</section>
<section>
</section>
<section>
</section>
<section>
<h2 class="section-title" id="header-functions">Functions</h2>
<dl>
<dt id="src.file_management.construct_filename"><code class="name flex">
<span>def <span class="ident">construct_filename</span></span>(<span>property_name: str)</span>
</code></dt>
<dd>
<div class="desc"><p>Return a filename of the following format:</p>
<p>"stats__" + <code>property_name</code> + "__" + timestamp + ".json"</p>
<p>The timestamp will be set according to the system time.</p>
<h2 id="parameters">Parameters</h2>
<dl>
<dt><strong><code>property_name</code></strong> :&ensp;<code>str</code></dt>
<dd>describes a property of teh database in words</dd>
</dl>
<h2 id="returns">Returns</h2>
<dl>
<dt><code>str</code></dt>
<dd>the filename following the format above</dd>
</dl></div>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def construct_filename(property_name: str):
    &#34;&#34;&#34;Return a filename of the following format:

    &#34;stats__&#34; + `property_name` + &#34;__&#34; + timestamp + &#34;.json&#34;

    The timestamp will be set according to the system time.


    Parameters
    ----------
    property_name: str
        describes a property of teh database in words

    Returns
    -------
    str
        the filename following the format above

    &#34;&#34;&#34;
    # create folder, if it not exists:
    Path(os.path.join(os.getcwd()), STATISTICS_FOLDER_NAME).mkdir(exist_ok=True)

    timestamp = int(datetime.now().timestamp()) # timestamp of when the data was saved
    # (it should be saved directly after running the query as it is more important to
    # know when the query was run that when it was saved)

    filename = &#34;{}/stats__{}__{}.json&#34;.format(STATISTICS_FOLDER_NAME, property_name, timestamp)

    return filename</code></pre>
</details>
</dd>
<dt id="src.file_management.find_all_stats_files"><code class="name flex">
<span>def <span class="ident">find_all_stats_files</span></span>(<span>property_name: str)</span>
</code></dt>
<dd>
<div class="desc"><p>Returns names of all json file containing collected statistical data
of the graph database property specified by <code>property_name</code>togehter with the
times of the database accesses.</p>
<h2 id="parameters">Parameters</h2>
<dl>
<dt><strong><code>name</code></strong> :&ensp;<code>str</code></dt>
<dd>The name of a graph property</dd>
</dl>
<h2 id="returns">Returns</h2>
<dl>
<dt><code>str</code></dt>
<dd>The filenames of all json files in the statistics folder
matching the following pattern:
"stats__" + <code>property_name</code> + "__" + timestamp + ".json"</dd>
<dt><code>datetime.datetime</code></dt>
<dd>The times when the stats files were created (usually immediately
after the database access)</dd>
</dl></div>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def find_all_stats_files(property_name: str):
    &#34;&#34;&#34;Returns names of all json file containing collected statistical data
    of the graph database property specified by `property_name`togehter with the
     times of the database accesses.

    Parameters
    ----------
    name: str
        The name of a graph property

    Returns
    -------
    str
        The filenames of all json files in the statistics folder
        matching the following pattern:
        &#34;stats__&#34; + `property_name` + &#34;__&#34; + timestamp + &#34;.json&#34;

    datetime.datetime
        The times when the stats files were created (usually immediately
         after the database access)

    &#34;&#34;&#34;
    data_files = find_stats_files(property_name)

    if not data_files:
        print(&#34;ERROR: File loading failed because there are no statistics of the requested property. Please check your spelling of the property name.&#34;)
        return None, None

    #extract timestamps from filname strs:
    timestamps = [int(filename.split(&#34;.&#34;)[0].split(&#34;__&#34;)[-1]) for filename in data_files]
    times = [datetime.fromtimestamp(timestamps[i]) for i in range(len(data_files))]

    return data_files, times</code></pre>
</details>
</dd>
<dt id="src.file_management.find_newest_stats_file"><code class="name flex">
<span>def <span class="ident">find_newest_stats_file</span></span>(<span>property_name: str)</span>
</code></dt>
<dd>
<div class="desc"><p>Returns name of newest json file containing collected statistical data
of the graph database property specified by <code>property_name</code> and the time of
the database access.</p>
<h2 id="parameters">Parameters</h2>
<dl>
<dt><strong><code>name</code></strong> :&ensp;<code>str</code></dt>
<dd>The name of a graph property</dd>
</dl>
<h2 id="returns">Returns</h2>
<dl>
<dt><code>str</code></dt>
<dd>The filename of the most recent json file in the statistics folder
matching the following pattern:
"stats__" + <code>property_name</code> + "__" + timestamp + ".json"</dd>
<dt><code>datetime.datetime</code></dt>
<dd>The time when the file was created</dd>
</dl></div>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def find_newest_stats_file(property_name: str):
    &#34;&#34;&#34;Returns name of newest json file containing collected statistical data
    of the graph database property specified by `property_name` and the time of
    the database access.

    Parameters
    ----------
    name: str
        The name of a graph property

    Returns
    -------
    str
        The filename of the most recent json file in the statistics folder
        matching the following pattern:
        &#34;stats__&#34; + `property_name` + &#34;__&#34; + timestamp + &#34;.json&#34;

    datetime.datetime
        The time when the file was created

    &#34;&#34;&#34;
    data_files = find_stats_files(property_name)

    if not data_files:
        print(&#34;ERROR: File loading failed because there are no statistics of the requested property. Please check your spelling of the property name.&#34;)
        return None, None

    #extract timestamps from filname strs:
    timestamps = [int(filename.split(&#34;.&#34;)[0].split(&#34;__&#34;)[-1]) for filename in data_files]
    times = [datetime.fromtimestamp(timestamps[i]) for i in range(len(data_files))]

    #find index of most recent file
    newest = times.index(max(times))

    return data_files[newest], times[newest]</code></pre>
</details>
</dd>
<dt id="src.file_management.find_sample_files"><code class="name flex">
<span>def <span class="ident">find_sample_files</span></span>(<span>sampling_method: str, size: int)</span>
</code></dt>
<dd>
<div class="desc"><p>Returns all names of pickle files containing serialized graph samples
of the graph database sampled by the specified method.</p>
<h2 id="parameters">Parameters</h2>
<dl>
<dt><strong><code>name</code></strong> :&ensp;<code>str</code></dt>
<dd>The name of a sampling method for which we want to find the created
samples.</dd>
<dt><strong><code>size</code></strong> :&ensp;<code>int</code></dt>
<dd>The size of the samples for which we want to find the files.</dd>
</dl>
<h2 id="returns">Returns</h2>
<dl>
<dt><code>list</code> of <code>str</code></dt>
<dd>The filenames of pickle files in the graph samples folder matching the
following pattern:
"sample__" + <code>sampling_method</code> + * + ".pickle"</dd>
</dl></div>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def find_sample_files(sampling_method:str, size:int):
    &#34;&#34;&#34;Returns all names of pickle files containing serialized graph samples
    of the graph database sampled by the specified method.

    Parameters
    ----------
    name: str
        The name of a sampling method for which we want to find the created
        samples.
    size: int
        The size of the samples for which we want to find the files.

    Returns
    -------
    list of str
        The filenames of pickle files in the graph samples folder matching the
        following pattern:
        &#34;sample__&#34; + `sampling_method` + * + &#34;.pickle&#34;
    &#34;&#34;&#34;
    files = [f for f in glob.glob(join(GRAPH_SAMPLES_FOLDER_NAME, &#39;sample__{}__{}__*.pickle&#39;.format(sampling_method, size)))]

    return files</code></pre>
</details>
</dd>
<dt id="src.file_management.find_stats_files"><code class="name flex">
<span>def <span class="ident">find_stats_files</span></span>(<span>property_name: str)</span>
</code></dt>
<dd>
<div class="desc"><p>Returns all names of json files containing collected statistical data
of the graph database property specified by <code>property_name</code>.</p>
<h2 id="parameters">Parameters</h2>
<dl>
<dt><strong><code>name</code></strong> :&ensp;<code>str</code></dt>
<dd>The name of a graph property</dd>
</dl>
<h2 id="returns">Returns</h2>
<dl>
<dt><code>list</code> of <code>str</code></dt>
<dd>The filenames of json files in the statistics folder matching the
following pattern:
"stats__" + <code>property_name</code> + "__" + timestamp + ".json"</dd>
</dl></div>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def find_stats_files(property_name: str):
    &#34;&#34;&#34;Returns all names of json files containing collected statistical data
    of the graph database property specified by `property_name`.

    Parameters
    ----------
    name: str
        The name of a graph property

    Returns
    -------
    list of str
        The filenames of json files in the statistics folder matching the
        following pattern:
        &#34;stats__&#34; + `property_name` + &#34;__&#34; + timestamp + &#34;.json&#34;
    &#34;&#34;&#34;
    files = [f for f in glob.glob(join(STATISTICS_FOLDER_NAME, &#39;stats__{}__*.json&#39;.format(property_name)))]
    return files</code></pre>
</details>
</dd>
<dt id="src.file_management.load_all_statistics"><code class="name flex">
<span>def <span class="ident">load_all_statistics</span></span>(<span>property_name: str)</span>
</code></dt>
<dd>
<div class="desc"><p>Loads all statistical data from a JSON-file inside the statistics folder.</p>
<h2 id="parameters">Parameters</h2>
<dl>
<dt><strong><code>property_name</code></strong> :&ensp;<code>str</code></dt>
<dd>name of a property of the graph database. This should also be the name of
a JSON file containing the desired statistics</dd>
</dl>
<h2 id="returns">Returns</h2>
<dl>
<dt><code>dict</code></dt>
<dd>The data from the json file specified by <code>filename</code></dd>
<dt><code>datetime.datetime</code></dt>
<dd>The time when the statistics file was created</dd>
</dl></div>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def load_all_statistics(property_name: str):
    &#34;&#34;&#34;Loads all statistical data from a JSON-file inside the statistics folder.

    Parameters
    ----------
    property_name: str
        name of a property of the graph database. This should also be the name of
        a JSON file containing the desired statistics

    Returns
    -------
    dict
        The data from the json file specified by `filename`
    datetime.datetime
        The time when the statistics file was created
    &#34;&#34;&#34;

    data_list = []
    time_created_list = []

    filenames, times_created = find_all_stats_files(property_name)
    for filename, time_created in zip(filenames,times_created):
        if filename:
            with open(filename, &#34;r&#34;) as read_file:
                data = json.load(read_file)

            data_list.append(data)
            time_created_list.append(time_created)
        else:
            data_list.append(None)
            time_created_list.append(None)

    return data_list, time_created_list</code></pre>
</details>
</dd>
<dt id="src.file_management.load_samples"><code class="name flex">
<span>def <span class="ident">load_samples</span></span>(<span>sampling_method: str, size: int)</span>
</code></dt>
<dd>
<div class="desc"><p>Returns all stored graph samples with specified parameters.</p>
<h2 id="parameters">Parameters</h2>
<dl>
<dt><strong><code>name</code></strong> :&ensp;<code>str</code></dt>
<dd>The name of a sampling method for which we want to find the created
samples.</dd>
<dt><strong><code>size</code></strong> :&ensp;<code>int</code></dt>
<dd>The size of the samples for which we want to find the files.</dd>
</dl>
<h2 id="returns">Returns</h2>
<dl>
<dt><code>list</code> of <code>nx.Graph</code></dt>
<dd>graph samples with specified sampling method and size</dd>
</dl></div>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def load_samples(sampling_method:str, size:int):
    &#34;&#34;&#34;Returns all stored graph samples with specified parameters.

    Parameters
    ----------
    name: str
        The name of a sampling method for which we want to find the created
        samples.
    size: int
        The size of the samples for which we want to find the files.

    Returns
    -------
    list of nx.Graph
        graph samples with specified sampling method and size
    &#34;&#34;&#34;
    files = find_sample_files(sampling_method, size)
    samples = []
    for filename in files:
        with open(filename, &#39;rb&#39;) as f:
            sample = pickle.load(f)
            samples.append(sample)
    return samples</code></pre>
</details>
</dd>
<dt id="src.file_management.load_statistics"><code class="name flex">
<span>def <span class="ident">load_statistics</span></span>(<span>property_name: str)</span>
</code></dt>
<dd>
<div class="desc"><p>Loads newest statistical data from a JSON-file inside the statistics
folder.</p>
<h2 id="parameters">Parameters</h2>
<dl>
<dt><strong><code>property_name</code></strong> :&ensp;<code>str</code></dt>
<dd>name of a property of the graph database. This should also be the name
of a JSON file containing the desired statistics</dd>
</dl>
<h2 id="returns">Returns</h2>
<dl>
<dt><code>dict</code></dt>
<dd>The data from the json file specified by <code>filename</code></dd>
<dt><code>datetime.datetime</code></dt>
<dd>The time when the statistics file was created</dd>
</dl></div>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def load_statistics(property_name: str):
    &#34;&#34;&#34;Loads newest statistical data from a JSON-file inside the statistics
    folder.

    Parameters
    ----------
    property_name: str
        name of a property of the graph database. This should also be the name
        of a JSON file containing the desired statistics

    Returns
    -------
    dict
        The data from the json file specified by `filename`
    datetime.datetime
        The time when the statistics file was created
    &#34;&#34;&#34;

    filename, time_created = find_newest_stats_file(property_name)
    if filename:
        with open(filename, &#34;r&#34;) as read_file:
            data = json.load(read_file)

        return data, time_created
    else:
        return None, None</code></pre>
</details>
</dd>
<dt id="src.file_management.save_plot"><code class="name flex">
<span>def <span class="ident">save_plot</span></span>(<span>property_name: str)</span>
</code></dt>
<dd>
<div class="desc"><p>Saves a matplotlib plot as png file in the plots folder.</p>
<p>The name of the saved image file will be of the following format:
"plot__" + <code>property_name</code> + "__" + timestamp + ".png"</p>
<h2 id="parameters">Parameters</h2>
<dl>
<dt><strong><code>property_name</code></strong> :&ensp;<code>str</code></dt>
<dd>The name of the property that the plots contains information of.</dd>
</dl></div>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def save_plot(property_name: str):
    &#34;&#34;&#34;Saves a matplotlib plot as png file in the plots folder.

    The name of the saved image file will be of the following format:
    &#34;plot__&#34; + `property_name` + &#34;__&#34; + timestamp + &#34;.png&#34;

    Parameters
    ----------
    property_name: str
        The name of the property that the plots contains information of.
    &#34;&#34;&#34;
    timestamp = int(datetime.now().timestamp()) # timestamp of when the plot was created
    filename = &#34;{}/plot__{}__{}.pdf&#34;.format(PLOTS_FOLDER_NAME, property_name, timestamp)
    plt.savefig(filename, format=&#34;pdf&#34;, dpi=300, bbox_inches = &#39;tight&#39;)

    print(&#34;Plot saved as {}.&#34;.format(filename))</code></pre>
</details>
</dd>
<dt id="src.file_management.save_sample"><code class="name flex">
<span>def <span class="ident">save_sample</span></span>(<span>graph: networkx.classes.graph.Graph, sampling_method: str)</span>
</code></dt>
<dd>
<div class="desc"><p>Saves a graph sample as both pickle file and gexf file.</p>
<p>A timestamp will be created which will be part of the filename of both
created files.</p>
<p>The pickle file will contained a serialized version of the networkx graph
that we can load again easily to further compute statistics on the sample.</p>
<p>The gexf file can be used to visualize the graph with Gephi.</p>
<h2 id="parameters">Parameters</h2>
<dl>
<dt><strong><code>graph</code></strong> :&ensp;<code>nx.Graph</code></dt>
<dd>A networkx graph object representing a graph sample.</dd>
<dt><strong><code>sampling_method</code></strong> :&ensp;<code>str</code></dt>
<dd>The name of the used sampling method,
e.g. random_walk or random_node_selection</dd>
</dl></div>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def save_sample(graph:nx.Graph, sampling_method:str):
    &#34;&#34;&#34; Saves a graph sample as both pickle file and gexf file.

    A timestamp will be created which will be part of the filename of both
    created files.

    The pickle file will contained a serialized version of the networkx graph
    that we can load again easily to further compute statistics on the sample.

    The gexf file can be used to visualize the graph with Gephi.


    Parameters
    ----------
    graph: nx.Graph
        A networkx graph object representing a graph sample.
    sampling_method: str
        The name of the used sampling method,
        e.g. random_walk or random_node_selection
    &#34;&#34;&#34;
    # Create timestamp of when the gexf file was created to
    # 1) distinguish between different samples with same parameters
    # 2) database is changing. File should be saved directly after sample
    #    creation to now in which state the database was a time of sampling
    timestamp = int(datetime.now().timestamp())
    sample_size = graph.number_of_nodes()
    filename_prefix = &#34;{}/sample__{}__{}__{}&#34;.format(GRAPH_SAMPLES_FOLDER_NAME, sampling_method, sample_size, timestamp)

    #save pickle:
    filename_pickle = filename_prefix + &#34;.pickle&#34;
    with open(filename_pickle, &#39;wb&#39;) as f:
        pickle.dump(graph, f)
    print(&#34;Sample graph saved as {}.&#34;.format(filename_pickle))

    #save gexf:
    filename_gexf = filename_prefix + &#34;.gexf&#34;
    nx.write_gexf(graph, filename_gexf)
    print(&#34;Gephi readable file saved as {}.&#34;.format(filename_gexf))</code></pre>
</details>
</dd>
<dt id="src.file_management.save_statistics_from_dataframe"><code class="name flex">
<span>def <span class="ident">save_statistics_from_dataframe</span></span>(<span>df, db_property: str)</span>
</code></dt>
<dd>
<div class="desc"><p>Saves database statistics from a dataframe to a newly created JSON file
in the statistics folder.</p>
<p>The name of the created file has the following format:
"stats__[<code>db_property</code>]__[timestamp].json"</p>
<h2 id="parameters">Parameters</h2>
<dl>
<dt><strong><code>df</code></strong> :&ensp;<code>'pandas.core.frame.DataFrame'</code></dt>
<dd>the statistical data that should be saved in JSON file</dd>
<dt><strong><code>db_property</code></strong> :&ensp;<code>str</code></dt>
<dd>Name of the property, of which <code>df</code> contains information. This name
will be part of the name of the created JSON file.</dd>
</dl></div>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def save_statistics_from_dataframe(df, db_property: str):
    &#34;&#34;&#34;Saves database statistics from a dataframe to a newly created JSON file
     in the statistics folder.

    The name of the created file has the following format:
    &#34;stats__[`db_property`]__[timestamp].json&#34;

    Parameters
    ----------
    df: &#39;pandas.core.frame.DataFrame&#39;
        the statistical data that should be saved in JSON file
    db_property: str
        Name of the property, of which `df` contains information. This name
        will be part of the name of the created JSON file.

    &#34;&#34;&#34;
    #data_dict = df.to_dict()
    #save_statistics_from_dict(data_dict, db_property)


    filename = construct_filename(db_property)

    df.to_json(filename, orient=&#39;columns&#39;)

    print(&#34;Data saved as {}.&#34;.format(filename))</code></pre>
</details>
</dd>
<dt id="src.file_management.save_statistics_from_dict"><code class="name flex">
<span>def <span class="ident">save_statistics_from_dict</span></span>(<span>statistics: dict, db_property: str)</span>
</code></dt>
<dd>
<div class="desc"><p>Saves database statistics from a dictionary to a newly created JSON file
in the statistics folder.</p>
<p>The name of the created file has the following format:
"stats__" + <code>db_property</code> + "__" + timestamp + ".json"</p>
<h2 id="parameters">Parameters</h2>
<dl>
<dt><strong><code>statistics</code></strong> :&ensp;<code>dictionary</code></dt>
<dd>the statistical data that should be saved. The exact structure of the
dict depends on the measured property</dd>
<dt><strong><code>db_property</code></strong> :&ensp;<code>str</code></dt>
<dd>describes the property of which the statistics should be saved</dd>
</dl></div>
<details class="source">
<summary>
<span>Expand source code</span>
</summary>
<pre><code class="python">def save_statistics_from_dict(statistics: dict, db_property: str):
    &#34;&#34;&#34;Saves database statistics from a dictionary to a newly created JSON file
     in the statistics folder.

    The name of the created file has the following format:
    &#34;stats__&#34; + `db_property` + &#34;__&#34; + timestamp + &#34;.json&#34;

    Parameters
    ----------
    statistics: dictionary
        the statistical data that should be saved. The exact structure of the
        dict depends on the measured property
    db_property: str
        describes the property of which the statistics should be saved

    &#34;&#34;&#34;

    filename = construct_filename(db_property)

    with open(filename, &#39;w&#39;) as file:
        json.dump(statistics, file)

    print(&#34;Data saved as {}.&#34;.format(filename))</code></pre>
</details>
</dd>
</dl>
</section>
<section>
</section>
</article>
<nav id="sidebar">
<h1>Index</h1>
<div class="toc">
<ul></ul>
</div>
<ul id="index">
<li><h3>Super-module</h3>
<ul>
<li><code><a title="src" href="index.html">src</a></code></li>
</ul>
</li>
<li><h3><a href="#header-functions">Functions</a></h3>
<ul class="">
<li><code><a title="src.file_management.construct_filename" href="#src.file_management.construct_filename">construct_filename</a></code></li>
<li><code><a title="src.file_management.find_all_stats_files" href="#src.file_management.find_all_stats_files">find_all_stats_files</a></code></li>
<li><code><a title="src.file_management.find_newest_stats_file" href="#src.file_management.find_newest_stats_file">find_newest_stats_file</a></code></li>
<li><code><a title="src.file_management.find_sample_files" href="#src.file_management.find_sample_files">find_sample_files</a></code></li>
<li><code><a title="src.file_management.find_stats_files" href="#src.file_management.find_stats_files">find_stats_files</a></code></li>
<li><code><a title="src.file_management.load_all_statistics" href="#src.file_management.load_all_statistics">load_all_statistics</a></code></li>
<li><code><a title="src.file_management.load_samples" href="#src.file_management.load_samples">load_samples</a></code></li>
<li><code><a title="src.file_management.load_statistics" href="#src.file_management.load_statistics">load_statistics</a></code></li>
<li><code><a title="src.file_management.save_plot" href="#src.file_management.save_plot">save_plot</a></code></li>
<li><code><a title="src.file_management.save_sample" href="#src.file_management.save_sample">save_sample</a></code></li>
<li><code><a title="src.file_management.save_statistics_from_dataframe" href="#src.file_management.save_statistics_from_dataframe">save_statistics_from_dataframe</a></code></li>
<li><code><a title="src.file_management.save_statistics_from_dict" href="#src.file_management.save_statistics_from_dict">save_statistics_from_dict</a></code></li>
</ul>
</li>
</ul>
</nav>
</main>
<footer id="footer">
<p>Generated by <a href="https://pdoc3.github.io/pdoc"><cite>pdoc</cite> 0.8.1</a>.</p>
</footer>
<script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/highlight.min.js"></script>
<script>hljs.initHighlightingOnLoad()</script>
</body>
</html>